addHook("MobjDamage", function(pmo, inf, src, _, dmgtype)
    if pmo.skin ~= "mmario" return end
    
    local p = pmo.player
    /*local angle = pmo.angle
    if (inf and inf.valid)
        angle = R_PointToAngle2(pmo.x, pmo.y, inf.x, inf.y)
    end*/
    
    if p.rings <= 0
        P_KillMobj(pmo, inf, src, dmgtype)
    else
        P_RemoveShield(p)
        P_DoPlayerPain(p, src, inf)
		if not p.powers[pw_shield]
			P_PlayerRingBurst(p)
			P_GivePlayerRings(p, -p.rings)
		end
        P_PlayRinglossSound(pmo)
        P_InstaThrust(pmo, R_PointToAngle2(pmo.x, pmo.y, pmo.x+pmo.momx, pmo.y+pmo.momy), 15*FU)
    end
    return true
end, MT_PLAYER)

-- decided adding this here since it technically is related to damage

freeslot("sfx_tydstp")

sfxinfo[sfx_tydstp].caption = "Boot-stomp"

addHook("MobjDeath", function(mo, pmo)
	if not (mo.flags & MF_ENEMY)
	or pmo.type ~= MT_PLAYER
	or pmo.skin ~= "mmario" return end
	
	local p = pmo.player
	if p.spinjum
	or (p.slide and pmo.z < mo.z+mo.height-4*FU)
	or (p.markick and pmo.z < mo.z+mo.height-4*FU)return end
	
	if pmo.z < mo.z+mo.height-4*FU return end
	
	p.sjenmy = mo
	if p.papermmario
		S_StartSound(mo, sfx_tydstp)
	else
		S_StartSound(mo, sfx_mario5)
	end
end)

freeslot("SPR_PMLK", "S_MAR_LUCKY", "MT_MAR_LUCKY", "sfx_tydlcy")

states[S_MAR_LUCKY] = {
	sprite = SPR_PMLK,
	frame = A,
	tics = -1,
	nextstate = S_NULL
}

mobjinfo[MT_MAR_LUCKY] = {
	doomednum = -1,
	spawnhealth = 1,
	spawnstate = S_MAR_LUCKY,
	deathstate = S_NULL,
	xdeathstate = S_NULL,
	deathsound = sfx_null,
	flags = MF_NOCLIP|MF_NOCLIPHEIGHT|MF_NOGRAVITY
}

sfxinfo[sfx_tydlcy].caption = "Lucky!"

addHook("ShouldDamage", function(mo, inf, _, _, dmgtype)
	if not (mo and mo.valid)
	or mo.skin ~= "mmario"
	or mo.player.powers[pw_flashing]
	or dmgtype == DMG_INSTAKILL return end
	
	local p = mo.player
	
	if P_RandomChance(FU/10)
		p.powers[pw_flashing] = TICRATE
		local lucky = P_SpawnMobj(mo.x, mo.y, mo.z+mo.height+5*FU, MT_MAR_LUCKY)
		lucky.luckytrans = 0
		lucky.drawonlyforplayer = p
		lucky.luckytimer = TICRATE/2
		lucky.lucky = 0
		lucky.target = mo
		S_StartSound(mo, sfx_tydlcy)
		return false
	end
end, MT_PLAYER)

addHook("MobjThinker", function(mo)
	if not (mo.target and mo.target.valid) P_RemoveMobj(mo) return end
	
	local pmo = mo.target
	local p = pmo.player
	
	local luckyease = ease.inback(mo.lucky, 5*FU, 20*FU, -5*FU)
	
	P_SetOrigin(mo, pmo.x, pmo.y, pmo.z+pmo.height+luckyease)
	if mo.lucky < FU
	and not mo.reverselucky
		mo.lucky = $+FU/(TICRATE/3)
	else
		if mo.luckytimer
			mo.luckytimer = $-1
		else
			P_RemoveMobj(mo)
		end
	end
	if (mo and mo.valid)
		mo.frame = $1|(mo.luckytrans/FU)<<FF_TRANSSHIFT
		if mo.lucky >= FU/2
			mo.luckytrans = $+9*FU/(TICRATE/2)
		end
	end
end, MT_MAR_LUCKY)