addHook("PlayerThink", function(p)
	if p.mo.skin ~= "mmario"
		if p.mmariohudactive
		and hud.enabled("lives")
			p.mmariohudactive = false
		end
		return
	end
	
	if not p.mmariohudactive
	and not hud.enabled("lives")
		p.mmariohudactive = true
	end
	
	if p.mmariohud.oupease < 0
		p.mmariohud.oupease = 0
	elseif p.mmariohud.oupease > FU
		p.mmariohud.oupease = FU
	end
	
	if p.mmariohud.oneup or (p.playerstate == PST_DEAD and not p.mmariohud.dead.active)--p.deadtimer < 3*TICRATE)
		if p.mmariohud.oupease < FU
			p.mmariohud.oupease = $+FU/(TICRATE/2)
		else
			if p.mmariohud.ouptime
				p.mmariohud.ouptime = $-1
			else
				if p.playerstate == PST_DEAD
					if not p.mmariohud.dead.bump
						p.mmariohud.hudlives = $-1
						S_StartSound(p.mo, sfx_smbbmp, p)
						p.mmariohud.dead.bump = true
					elseif not S_SoundPlaying(p.mo, sfx_smbbmp)
					and p.mmariohud.dead.bump
						p.mmariohud.dead.active = true
					end
				else
					p.mmariohud.hudlives = $+1
					S_StopSoundByID(p.mo, sfx_marioa)
					S_StartSound(p.mo, sfx_marioa, p)
					p.mmariohud.ouptime = 360*TICRATE
					if p.mmariohud.oupgained > 1
						p.mmariohud.oupgained = $-1
					end
				end
			end
		end
	elseif p.mmariohud.oupease > 0
		p.mmariohud.oupease = $-FU/(TICRATE/2)
	elseif p.mmariohud.ouptime ~= TICRATE/2
		p.mmariohud.ouptime = TICRATE/2
	elseif p.mmariohud.hudlives ~= p.lives
	and p.playerstate ~= PST_DEAD
		p.mmariohud.hudlives = p.lives
	end
end)

freeslot("SPR_SPNT")

local function drawPSpeed(v, x, y, flags, ps)
	for i = 0, 6 do
		local patch = v.cachePatch("PSPEED1")
		if i == 6
			patch = v.cachePatch("PSPEEDP1")
		end
		if i <= ps-1
		and (leveltime%10 <= 5 or i ~= 6)
			if i == 6
				patch = v.cachePatch("PSPEEDP2")
			else
				patch = v.cachePatch("PSPEED2")
			end
		end
		
		v.draw(x+8*i, y, patch, flags)
	end
end

addHook("HUD", function(v, p)
	if p.mo.skin ~= "mmario" 
		if p.mmariohudactive
			hud.enable("lives")
			hud.enable("rings")
			hud.enable("score")
			hud.enable("time")
		end
		return
	end
	
	if not p.mmariohudactive
		hud.disable("lives")
		hud.disable("rings")
		hud.disable("score")
		hud.disable("time")
	end
	
	local yease = ease.inoutsine(p.mmariohud.oupease, -16*FU, 23*FU)
	local y = yease/FU
	local pcolor = v.getColormap(p.skin, p.mo.color)
	local ssbg = v.getSpritePatch(SPR_SPNT, A, 0, FixedAngle(15*FU))
	v.drawScaled(131*FU, yease+9*FU, FU/2, ssbg, V_PERPLAYER|V_SNAPTOTOP|V_30TRANS)
	v.drawScaled(134*FU, yease-6*FU, FU/2, v.cachePatch("MMHEAD"), V_PERPLAYER|V_SNAPTOTOP, pcolor)
	v.drawString(163*FU, yease-5*FU, tostring(p.mmariohud.hudlives), V_PERPLAYER|V_SNAPTOTOP, "fixed-center")
	
	v.drawScaled(16*FU, 32*FU, FU/2, ssbg, V_PERPLAYER|V_SNAPTOTOP|V_SNAPTOLEFT|V_30TRANS)
	v.drawScaled(19*FU, 18*FU, FU, v.cachePatch("SSCOINSHAD"), V_SNAPTOTOP|V_SNAPTOLEFT|V_PERPLAYER|V_50TRANS)
	v.drawScaled(19*FU, 18*FU, FU, v.cachePatch("SSCOIN"), V_SNAPTOTOP|V_SNAPTOLEFT|V_PERPLAYER)
	v.drawString(42*FU, 18*FU, tostring(p.rings), V_PERPLAYER|V_SNAPTOTOP|V_SNAPTOLEFT, "fixed-center")
	
	--P-Speed thing :D
	drawPSpeed(v, 16, 43, V_SNAPTOTOP|V_SNAPTOLEFT|V_PERPLAYER, p.pspeed.time/25)
end, "game")