freeslot("S_MAR_KICK", "SPR2_MKIC", "sfx_smbbmp")

states[S_MAR_KICK] = {
    sprite = SPR_PLAY,
    frame = SPR2_MKIC,
    tics = 50,
    nextstate = S_MAR_KICK
}

sfxinfo[sfx_smbbmp].caption = "Bump"

addHook("PlayerThink", function(player)
    if player.mo.skin ~= "mmario" return end
	
	if (player.cmd.buttons & BT_CUSTOM2)
	and not (player.pflags & PF_THOKKED)
	and not player.crouch
	and not P_PlayerInPain(player)
	and player.speed >= 3*FU
	and not player.galtwirl
	and not player.groundgaltwirl
	and not player.nsmbtwirl
	and not (player.mo.eflags & MFE_UNDERWATER)
	and not player.markick
	and not player.groundpound
	and not player.wingcapflight
	and player.playerstate  ~= PST_DEAD
	and player.powers[pw_carry] == CR_NONE
		player.markicklanded = false
		P_SetOrigin(player.mo, player.mo.x, player.mo.y, player.mo.z+FU*P_MobjFlip(player.mo))
		P_SetObjectMomZ(player.mo, 10*FRACUNIT, false)
		--P_InstaThrust(player.mo, player.mo.angle, 43*FRACUNIT)
		P_InstaThrust(player.mo, player.mo.angle, 53*FU)
		player.markickspeed = player.speed
		player.mo.state = S_MAR_KICK
		player.markick = true
		P_MovePlayer(player)
		player.pflags = $|PF_THOKKED
		player.powers[pw_strong] = $1|STR_ATTACK|STR_SPIKE|STR_ANIM|STR_WALL
	end
	
	if player.markick
		player.powers[pw_strong] = $1|STR_ATTACK|STR_SPIKE|STR_ANIM|STR_WALL
		if ((player.pflags & PF_JUMPED) and player.markicklanded)--player.markickground)
		or P_PlayerInPain(player)
		--or (player.mo.eflags & MFE_SPRUNG)
		or (player.speed <= 3*FU and player.markicklanded)--player.markickground)
		or (player.mo.eflags & MFE_UNDERWATER)
			player.markick = false
		end
		--if player.markickground
		if player.markicklanded
			player.pflags = $1|PF_SPINNING
			player.powers[pw_strong] = $1|STR_SPRING
			--P_InstaThrust(player.mo, player.drawangle, player.markickspeed)
		end
		
		if P_IsObjectOnGround(player.mo)
			P_SpawnSkidDust(player, player.speed, sfx_s3k47)
			--player.markickground = true
			player.mo.state = S_MAR_KICK
			if not player.markicklanded
				player.markicklanded = true
			end
			/*if player.mo.standingslope
				local mo = player.mo
				local slope = mo.standingslope
				local x = cos(slope.xydirection)
				local y = sin(slope.xydirection)
				local angle = slope.xydirection
				if P_GetZAt(slope, mo.x+32*x, mo.y+32*y) > P_GetZAt(slope, mo.x, mo.y)
					angle = slope.xydirection+ANGLE_180
				end
				local angle45 = (AngleFixed(angle)+45*FU)/FU
				local angle45m = (AngleFixed(angle)-45*FU)/FU
				if player.drawangle <= FixedAngle(angle45*FU)
				and player.drawangle >= FixedAngle(angle45m*FU)
					player.markickspeed = $+FU/(TICRATE/5)
				else
					player.markickspeed = $-FU/(TICRATE/5)
				end
			else
				player.markickspeed = $-FU/(TICRATE/5)
			end*/
		end
	elseif player.markicklanded
		player.markicklanded = false
		player.pflags = $ & ~PF_SPINNING
	elseif player.mo.state == S_MAR_KICK
		if P_IsObjectOnGround(player.mo)
			player.mo.state = S_PLAY_WALK
		else
			player.mo.state = S_PLAY_JUMP
		end
	end
	
	if player.markickflashing
		if P_IsObjectOnGround(player.mo)
			player.markickflashing = false
		else
			player.powers[pw_flashing] = TICRATE+TICRATE/2
		end
	end
end)

addHook("MobjMoveBlocked", function(pmo)
	if pmo.skin ~= "mmario"
	or not pmo.player.markick return end
	
	local p = pmo.player
	
	p.markick = false
	P_DoPlayerPain(p)
	if p.markickspeed/3 < 3*FU
		P_InstaThrust(pmo, R_PointToAngle2(pmo.x, pmo.y, pmo.x+pmo.momx, pmo.y+pmo.momy), 3*FU)
	else
		P_InstaThrust(pmo, R_PointToAngle2(pmo.x, pmo.y, pmo.x+pmo.momx, pmo.y+pmo.momy), p.markickspeed/3)
	end
	
	--S_StartSound(pmo, sfx_s3k49)
	S_StartSound(pmo, sfx_smbbmp)
	if not G_RingSlingerGametype()
		p.markickflashing = true
	else
		p.powers[pw_flashing] = 2*TICRATE
	end
end, MT_PLAYER)

addHook("PlayerHeight", function(p)
	if p.mo.skin ~= "mmario" return end
	
	if p.markick return P_GetPlayerSpinHeight(p) end
end)

addHook("PlayerCanEnterSpinGaps", function(p)
	if p.mo.skin ~= "mmario" return end
	
	if p.markick return true end
end)