
-- paper mario
-- hooray

freeslot("SKINCOLOR_PUREWHITE")

skincolors[SKINCOLOR_PUREWHITE] = {
	name = "Pure White",
	ramp = {0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0},
	invcolor = SKINCOLOR_BLACK,
	invshade = 0,
	chatcolor = V_GRAYMAP,
	accessible = true
}

freeslot("S_PAPEROVERLAY")

states[S_PAPEROVERLAY] = {
	sprite = SPR_PLAY,
	frame = SPR2_STND,
	var1 = 1,
	tics = -1,
	nextstate = S_PAPEROVERLAY
}

local function createPaperOutline(p)
	local thing = P_SpawnMobj(p.mo.x, p.mo.y, p.mo.z, MT_OVERLAY)
	thing.target = p.mo
	thing.state = S_PAPEROVERLAY
	thing.skin = p.mo.skin
	thing.paperoutline = true
	thing.spritexoffset = p.mo.spritexoffset
	thing.spriteyoffset = p.mo.spriteyoffset
	thing.dispoffset = -1
	thing.flags2 = p.mo.flags2
	thing.eflags = p.mo.eflags
	--thing.spritexscale = FU+FU/35
	--thing.spriteyscale = FU+FU/35
	thing.colorized = true
	thing.color = SKINCOLOR_PUREWHITE
	thing.frame = p.mo.frame
	thing.renderflags = p.mo.renderflags
	thing.angle = p.drawangle
	return thing
end

freeslot("SPR_PMPR", "S_MAR_PERIL", "MT_MAR_PERIL", "sfx_pmjump", "sfx_tyddmg", "sfx_tydprl")

states[S_MAR_PERIL] = {
	sprite = SPR_PMPR,
	frame = A,
	tics = -1,
	nextstate = S_NULL
}

mobjinfo[MT_MAR_PERIL] = {
	doomednum = -1,
	spawnhealth = 1,
	spawnstate = S_MAR_PERIL,
	deathstate = S_NULL,
	xdeathstate = S_NULL,
	deathsound = sfx_null,
	flags = MF_NOCLIP|MF_NOCLIPHEIGHT|MF_NOGRAVITY
}

sfxinfo[sfx_pmjump].caption = "Jump"
sfxinfo[sfx_tyddmg].caption = "Ring loss"
sfxinfo[sfx_tydprl].caption = "Peril!"

addHook("ThinkFrame", function()
	for p in players.iterate do
		if not (p.mo and p.mo.valid)
		or p.mo.skin ~= "mmario"
		or not p.papermmario 
			if (p.paperoverlay and p.paperoverlay.active)
				local omobjs = p.paperoverlay.mobjs
				for i = 1, #omobjs do
					if not (p.paperoverlay.mobjs[i] and p.paperoverlay.mobjs[i].valid) continue end
					
					P_RemoveMobj(p.paperoverlay.mobjs[i])
					if i == #omobjs
						p.paperoverlay.active = false
					end
				end
			end
			continue
		end
		
		if not (p.mo.renderflags & RF_PAPERSPRITE)
			p.mo.renderflags = $1|RF_PAPERSPRITE
		end
		
		if S_SoundPlaying(p.mo, skins[p.mo.skin].soundsid[SKSJUMP])
			S_StopSoundByID(p.mo, skins[p.mo.skin].soundsid[SKSJUMP])
			S_StartSound(p.mo, sfx_pmjump)
		end
		for i = 1, 4 do
			if S_SoundPlaying(p.mo, skins[p.mo.skin].soundsid[_G["SKSPLPAN"+tostring(i)]])
				S_StopSoundByID(p.mo, skins[p.mo.skin].soundsid[_G["SKSPLPAN"+tostring(i)]])
				S_StartSound(p.mo, sfx_tyddmg)
			end
		end
		
		if p.rings == 0
		and not S_SoundPlaying(p.mo, sfx_tydprl)
			S_StartSound(p.mo, sfx_tydprl, p)
			if not p.peril
				p.peril = P_SpawnMobj(p.mo.x, p.mo.y, p.mo.z+p.mo.height+10*FU, MT_MAR_PERIL)
				p.peril.target = p.mo
			end
		end
		p.mo.spriteyoffset = FU
		p.drawangle = p.mo.angle+ANGLE_90
		if not p.paperoverlay.active
			local thing = createPaperOutline(p)
			local thing2 = createPaperOutline(p)
			local thing3 = createPaperOutline(p)
			local thing4 = createPaperOutline(p)
			local offset = FU
			thing.spritexoffset = $+offset
			thing.spriteyoffset = $+offset
			thing2.spritexoffset = $-offset
			thing2.spriteyoffset = $-offset
			thing3.spritexoffset = $-offset
			thing3.spriteyoffset = $+offset
			thing4.spritexoffset = $+offset
			thing4.spriteyoffset = $-offset
			P_SetOrigin(thing, p.mo.x, p.mo.y, p.mo.z)
			P_SetOrigin(thing2, p.mo.x, p.mo.y, p.mo.z)
			P_SetOrigin(thing3, p.mo.x, p.mo.y, p.mo.z)
			P_SetOrigin(thing4, p.mo.x, p.mo.y, p.mo.z)
			p.paperoverlay.active = true
			p.paperoverlay.mobjs[1] = thing
			p.paperoverlay.mobjs[2] = thing2
			p.paperoverlay.mobjs[3] = thing3
			p.paperoverlay.mobjs[4] = thing4
		else
			local omobjs = p.paperoverlay.mobjs
			for i = 1, #omobjs do
				if not (p.paperoverlay.mobjs[i] and p.paperoverlay.mobjs[i].valid) continue end
				
				p.paperoverlay.mobjs[i].state = S_PAPEROVERLAY
				p.paperoverlay.mobjs[i].sprite = p.mo.sprite
				p.paperoverlay.mobjs[i].sprite2 = p.mo.sprite2
				p.paperoverlay.mobjs[i].flags2 = p.mo.flags2
				p.paperoverlay.mobjs[i].eflags = p.mo.eflags
				p.paperoverlay.mobjs[i].rollangle = p.mo.rollangle
				p.paperoverlay.mobjs[i].frame = p.mo.frame
				p.paperoverlay.mobjs[i].skin = p.mo.skin
			end
		end
	end
end)

addHook("MobjThinker", function(mo)
	if not (mo.target and mo.target.valid) return end
	
	local pmo = mo.target
	local p = pmo.player
	
	if leveltime%10 <= 5
		mo.flags2 = $1|MF2_DONTDRAW
	else
		mo.flags2 = $ & ~MF2_DONTDRAW
	end
	
	if p.rings ~= 0
	or not p.papermmario
	or pmo.skin ~= "mmario"
		p.peril = nil
		P_RemoveMobj(mo)
	end
	if (mo and mo.valid)
		P_MoveOrigin(mo, pmo.x, pmo.y, pmo.z+pmo.height+15*FU)
	end
end, MT_MAR_PERIL)