
-- wario land 4
-- reference

addHook("PlayerThink", function(p)
	if not PTSR
	or gametype ~= GT_PTSPICER return end
	
	if p.mo.skin ~= "mmario"
		if p.mmariopthud
			customhud.enable("PTSR_bar")
			p.mmariopthud.enabled = false
		end
		return
	end
	
	if not p.mmariopthud.enabled
		p.mmariopthud.enabled = true
	end
	
	if PTSR.pizzatime
		if not PTSR.timeover
			if leveltime%3 == 0
				p.mmariopthud.shakeease = P_RandomFixed()
				p.mmariopthud.shakeeases = P_RandomFixed()
			end
		else
			p.mmariopthud.shakeease = 0
			p.mmariopthud.shakeeases = 0
		end
		if not (PTSR.timeover or p.playerstate == PST_DEAD)
			if p.mmariopthud.easething < FU
				p.mmariopthud.easething = $+FU/(2*TICRATE)
			elseif p.mmariopthud.easething > FU
				p.mmariopthud.easething = FU
			end
		end
	end
	if PTSR.timeover
	or p.playerstate == PST_DEAD
		if p.mmariopthud.easething > 0
			p.mmariopthud.easething = $-FU/(2*TICRATE)
		elseif p.mmariopthud.easething < 0
			p.mmariopthud.easething = 0
		end
	end
end)

local function drawSMB1Num(v, x, y, num, scale, flags)
	local snum = tostring(num)
	local length = tonumber(string.len(snum))
	for i = 0, length-1 do
		local curNum = string.sub(snum, i+1, i+1)
		v.drawScaled(x+(8*i*scale), y, scale, v.cachePatch("SMBNUM"+curNum), flags)
	end
end

local function drawSMB1String(v, x, y, str, scale, flags)
	local strg = string.upper(str)
	local length = tonumber(string.len(strg))
	for i = 0, length-1 do
		local curLtr = string.sub(strg, i+1, i+1)
		v.drawScaled(x+(8*i*scale), y, scale, v.cachePatch("SMBLT"+curLtr), flags)
	end
end

addHook("HUD", function(v, p)
	if p.mo.skin ~= "mmario"
	or not PTSR
	or gametype ~= GT_PTSPICER return end
	
	if p.mmariopthud.enabled
		customhud.disable("PTSR_bar")
	end
	
	local secstime = 0
	if PTSR.pizzatime_tics ~= nil
		--secstime = G_TicsToMinutes(PTSR.pizzatime_tics, true)*60+G_TicsToSeconds(PTSR.pizzatime_tics)
		secstime = G_TicsToMinutes(PTSR.timeleft, true)*60+G_TicsToSeconds(PTSR.timeleft)
	end
	
	local easething = ease.inoutsine(p.mmariopthud.easething, 0, -16*FU)
	local easething2 = ease.inoutsine(p.mmariopthud.easething, 0, (-19*2)*FU)
	local shakeease = ease.linear(p.mmariopthud.shakeease, -5*FU, 5*FU)
	local shakeease2 = ease.linear(p.mmariopthud.shakeeases, -5*FU, 5*FU)
	if not PTSR.pizzatime
		shakeease = 0
		shakeease2 = 0
	end
	local pcolor = v.getColormap(p.mo.skin, p.mo.color)
	local tiny = v.cachePatch("TINYMMARIO")
	if p.mo.colorized
		tiny = v.cachePatch("TINYMMARIOCRSD")
	end
	
	v.drawScaled(FixedDiv(320*FU, 2*FU)-(17*2)*FU+shakeease, 200*FU+easething2-shakeease2, FU*2, tiny, V_SNAPTOBOTTOM|V_PERPLAYER, pcolor)
	
	if PTSR.timeover
		drawSMB1String(v, FixedDiv(320*FU, 2*FU), 200*FU+easething, "OVERTIME", FU*2, V_SNAPTOBOTTOM|V_PERPLAYER)
	else
		drawSMB1Num(v, FixedDiv(320*FU, 2*FU), 200*FU+easething, secstime, FU*2, V_SNAPTOBOTTOM|V_PERPLAYER)
	end
end, "game")