freeslot("S_MAR_SPIN")

states[S_MAR_SPIN] = {
    sprite = SPR_PLAY,
    frame = SPR2_SPIN,
    tics = 3,
    nextstate = S_MAR_SPIN
}

freeslot("sfx_smwspn", "sfx_smwssp", "sfx_smwstp")

sfxinfo[sfx_smwspn].caption = "Spin Jump"
sfxinfo[sfx_smwssp].caption = "Super Stomp"
sfxinfo[sfx_smwstp].caption = "Stomp"

freeslot("sfx_spmlsj")

sfxinfo[sfx_spmlsj].caption = "Super Jump"

addHook("PlayerThink", function(player)
	if player.mo.skin == "mmario"
		if (player.cmd.buttons & BT_CUSTOM1)
		and not (player.pflags & PF_THOKKED)
		and not (player.mo.eflags & MFE_JUSTHITFLOOR)
		and not (player.mo.eflags & MFE_UNDERWATER)
		and not player.groundgalspin
		and not player.nsmbspin
		and not player.markick
		and not player.crouch
		and not player.slide
		and not player.groundpound
		and not P_PlayerInPain(player)
		and P_IsObjectOnGround(player.mo)
			player.spinjum = true
			if player.papermmario
				S_StartSound(player.mo, sfx_spmlsj)
			else
				S_StartSound(player.mo, sfx_smwspn)
			end
			P_SetObjectMomZ(player.mo, 15*FRACUNIT, false)
			player.mo.state = S_MAR_SPIN
			player.pflags = $|PF_THOKKED
			player.powers[pw_strong] = $1|STR_CEILING|STR_FLOOR|STR_ANIM--|STR_ATTACK|STR_ANIM|STR_CEILING|STR_FLOOR
		end
		
		if player.spinjum
			player.powers[pw_strong] = $1|STR_CEILING|STR_FLOOR|STR_ANIM
			--local num = FU/3
			local num = FU/4
			local maxmom = -10*FU
			if player.twirlstyle ~= 1
				num = FU/4
				maxmom = -15*FU
			end
			if (player.cmd.buttons & BT_JUMP)
				maxmom = $/2
			end
			
			if not (player.cmd.buttons & BT_CUSTOM3)
				/*if (player.mo.momz < 0 and not (player.mo.eflags & MFE_VERTICALFLIP))
				or (player.mo.momz > 0 and (player.mo.eflags & MFE_VERTICALFLIP))
					P_SetObjectMomZ(player.mo, num, true)
				end*/
				local grav = P_GetMobjGravity(player.mo)
				if (player.mo.eflags & MFE_VERTICALFLIP)
					grav = -$
				end
				P_SetObjectMomZ(player.mo, -grav/4, true)
				
				if (player.mo.momz < maxmom and not (player.mo.eflags & MFE_VERTICALFLIP))
				or (player.mo.momz > -maxmom and (player.mo.eflags & MFE_VERTICALFLIP))
					P_SetObjectMomZ(player.mo, maxmom)
				end
			end
			
			if (player.mo.eflags & MFE_JUSTHITFLOOR)
			or (player.mo.eflags & MFE_SPRUNG)
			or (player.mo.eflags & MFE_UNDERWATER)
			or player.playerstate == PST_DEAD
			or P_PlayerInPain(player)
			or player.powers[pw_carry] then
				player.spinjum = false
				--player.mo.state = S_PLAY_STND
			end
		end
	end
end)

addHook("ThinkFrame", function()
	for p in players.iterate do
		if p.mo.skin ~= "mmario"
		or not (p.sjenmy and p.sjenmy.valid) continue end
		
		if p.sjenmy.info.deathsound ~= sfx_mario5
		or p.spinjum
			S_StopSoundByID(p.sjenmy, p.sjenmy.info.deathsound)
		end
	end
end)

addHook("MobjMoveBlocked", function(pmo)
	if pmo.skin ~= "mmario"
	or not pmo.player.spinjum
	or pmo.player.speed < 3*FU return end
	
	S_StartSound(pmo, sfx_smbbmp)
	P_BounceMove(pmo)
end, MT_PLAYER)

addHook("ShouldDamage", function(pmo, inf, _, _, dmg)
	if not pmo.player.spinjum return end
	
	if not (inf and inf.valid)
	or dmg ~= DMG_SPIKE return end
	
	if ((inf and inf.valid) and not ((inf.flags & MF_PAIN) and pmo.z >= inf.z+inf.height-5*FU))
	or dmg ~= DMG_SPIKE return end
	
	local p = pmo.player
	
	pmo.eflags = $ & ~MFE_JUSTHITFLOOR
	p.pflags = $ & ~PF_JUMPED
	P_DoJump(p, false)
	pmo.state = S_MAR_SPIN
	S_StartSound(pmo, sfx_smwstp)
	return false
end, MT_PLAYER)

addHook("MobjDeath", function(mo, inf, src, dmg)
	if not (mo.flags & MF_ENEMY)
	or not (inf and inf.valid)
	or inf.skin ~= "mmario"
	or not inf.player.spinjum return end
	
	local p = inf.player
	p.sjenmy = mo
	p.sjenmykilled = true
	P_SetObjectMomZ(inf, FixedDiv(abs(inf.momz), FixedDiv(3*FU, 2*FU)))
	S_StartSound(mo, sfx_smwssp)
end)