
-- the cvar is defined in marvars.lua (first lua there is)
-- so other luas (marspin.lua) can use it

freeslot("S_MAR_NSMBSPIN", "sfx_nmbtwl", "sfx_smgsak")

states[S_MAR_NSMBSPIN] = {
    sprite = SPR_PLAY,
    frame = SPR2_SPIN|FF_SPR2ENDSTATE,
    tics = 2,
	var1 = S_PLAY_FALL,
    nextstate = S_MAR_NSMBSPIN
}

sfxinfo[sfx_nmbtwl].caption = "Twirl"
sfxinfo[sfx_smgsak].caption = "Spin Attack"

freeslot("sfx_pmspnj")

sfxinfo[sfx_pmspnj].caption = "Tornado Jump"

addHook("AbilitySpecial", function(player)
	if player.mo.skin == "mmario" then
		if player.powers[pw_super] return end
		
		--local twirl = CV_FindVar("mario_twirlstyle").value
		local twirl = player.twirlstyle
		if not player.wallslide
		and not player.markick
		and not player.crouch
		and not player.spinjum
		and not player.groundpound
		and not P_IsObjectOnGround(player.mo)
		and not (player.mo.eflags & MFE_UNDERWATER)
		and not P_PlayerInPain(player)
			if twirl ~= 1
			and not (player.pflags & PF_THOKKED)
				S_StartSound(player.mo, sfx_smgsak)
				player.galtwirl = true
				P_SetObjectMomZ(player.mo, 10*FRACUNIT, false)
				player.mo.state = S_MAR_SPIN
				player.pflags = $|PF_THOKKED
				player.powers[pw_strong] = $1|STR_ATTACK|STR_ANIM|STR_SPRING|STR_WALL|STR_SPIKE
			elseif twirl ~= 2
			and not player.nsmbcooldown
			and (twirl ~= 3 or ((player.pflags & PF_THOKKED) and not player.galtwirl))
				if player.papermmario
					S_StartSound(player.mo, sfx_pmspnj)
				else
					S_StartSound(player.mo, sfx_nmbtwl)
				end
				player.mo.state = S_MAR_NSMBSPIN
				player.nsmbtwirl = true
				player.nsmbcooldown = TICRATE/2
				player.mo.momz = 0
			end
		end
	end
end)

addHook("ThinkFrame", function()
	for p in players.iterate do
		if not (p.mo and p.mo.valid)
		or p.mo.skin ~= "mmario"
		or not (p.galtwirl or p.groundgaltwirl) continue end
		
		if p.mo.state == S_MAR_SPIN
		and p.mo.frame == D
		and p.mo.tics == 1
			p.galtwirlspins = $+1
		end
	end
end)

addHook("PlayerThink", function(player)
	if player.mo.skin ~= "mmario" return end
	
	if player.twirlstyle ~= 1
		if (player.cmd.buttons & BT_FIRENORMAL)
		or (player.cmd.buttons & BT_ATTACK)
			player.galfireheld = $+1
		else
			player.galfireheld = 0
		end
		
		if player.galfireheld == 1
		and not player.groundgaltwirl
		and not player.galtwirl
		and not player.slide
		and not player.markick
		and P_IsObjectOnGround(player.mo)
		and not G_RingSlingerGametype()
		and not (player.powers[pw_shield] & SH_FIREFLOWER)
		and not P_PlayerInPain(player)
			player.mo.state = S_MAR_SPIN
			S_StartSound(player.mo, sfx_smgsak)
			player.powers[pw_strong] = $1|STR_ATTACK|STR_ANIM|STR_SPRING|STR_WALL|STR_SPIKE
			player.groundgaltwirl = true
			if player.crouch
				player.crouch = false
			end
		end
	end
	
	if player.galtwirl
	or player.groundgaltwirl
		if player.mo.state ~= S_MAR_SPIN
			player.mo.state = S_MAR_SPIN
		end
		if player.groundgaltwirl
			player.pflags = $1|PF_JUMPSTASIS
		end
		player.galangle = $+13
		if player.galangle >= 360
			player.galangle = $-360
		end
		local x = cos(FixedAngle(player.galangle*FU))
		local y = sin(FixedAngle(player.galangle*FU))
		local spark = P_SpawnMobjFromMobj(player.mo, 16*x, 16*y, 0, MT_IVSP)
		spark.tics = 5
		spark.dispoffset = 0
		if (player.mo.eflags & MFE_JUSTHITFLOOR)
		or (player.mo.eflags & MFE_SPRUNG)
		or (player.mo.eflags & MFE_UNDERWATER)
		or player.galtwirlspins == 2
		or (player.groundgaltwirl and (player.pflags & PF_JUMPED))
		or P_PlayerInPain(player) then
			if player.mo.state == S_MAR_SPIN
				if P_IsObjectOnGround(player.mo)
					player.mo.state = S_PLAY_WALK
				else
					player.mo.state = S_PLAY_FALL
				end
			end
			player.groundgaltwirl = false
			player.galtwirl = false
		end
	elseif player.galangle
		player.galangle = 0
	elseif player.galtwirlspins
		player.galtwirlspins = 0
	end
	
	if (player.cmd.buttons & BT_JUMP)
		player.nsmbjumpheld = $+1
	else
		player.nsmbjumpheld = 0
	end
	
	local twirl = player.twirlstyle
	if twirl ~= 2
	and player.nsmbjumpheld == 1
	and not player.nsmbcooldown
	and not (player.pflags & PF_JUMPED)
	and not player.galtwirl
	and not player.spinjum
	and not player.markick
	and not player.slide
	and not player.crouch
	and not player.wallslide
	and not player.groundpound
	and not P_PlayerInPain(player)
	and not P_IsObjectOnGround(player.mo)
	and not (player.mo.eflags & MFE_UNDERWATER)
	and player.playerstate ~= PST_DEAD
		if player.papermmario
			S_StartSound(player.mo, sfx_pmspnj)
		else
			S_StartSound(player.mo, sfx_nmbtwl)
		end
		player.mo.state = S_MAR_NSMBSPIN
		player.nsmbtwirl = true
		player.nsmbcooldown = TICRATE/2
		player.mo.momz = 0
	end
	
	if player.nsmbtwirl
		player.mo.momz = 0
		if player.mo.state ~= S_MAR_NSMBSPIN
		or (player.mo.eflags & MFE_SPRUNG)
		or (player.mo.eflags & MFE_UNDERWATER)
			player.nsmbtwirl = false
		end
	elseif player.nsmbcooldown
		player.nsmbcooldown = $-1
	end
end)